INSTANCESELECT_WIDTH = 200
WINDOW_OPACITY = 0.8

---------------------------------------------------------------------
--== Window ===--
---------------------------------------------------------------------

Window = class( Turbine.UI.Window )

function Window:Constructor()
	Turbine.UI.Window.Constructor( self )

	self.selected_content = nil
	self.selected_instance = nil

	self:SetPosition(LootSettings["window"]["left"],LootSettings["window"]["top"])
	self:SetSize(LootSettings["window"]["width"],LootSettings["window"]["height"])
	self:SetMouseVisible(false)

	self.InstanceSelect = WindowInstanceSelect(self)
	self.InstanceSelect:SetParent(self)
	self.InstanceSelect:SetZOrder(1)

	self.Logs = WindowLogs(self)
	self.Logs:SetParent(self)
	self.Logs:SetZOrder(1)

	self:SetWantsKeyEvents(true)

    self.KeyDown = function(sender, args)
        if args.Action == 145 then
            self:Close()
        end
    end
	
	self.topBar = Turbine.UI.Control()
	self.topBar:SetParent(self)
	self.topBar:SetSize(self:GetWidth(), 25)
	--self.topBar:SetZOrder(5)
	self.topBar.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = true	
			self.dragStartX = args.X
			self.dragStartY = args.Y
		end
	end
	
	self.topBar.MouseMove = function( sender, args )
		if self.dragging then
			local x,y = self:GetPosition()	
			x = x + ( args.X - self.dragStartX )
			y = y + ( args.Y - self.dragStartY )	

			if x < 0 then
				x = 0
			end
			if y < 0 then
				y = 0
			end
			local max_x = Turbine.UI.Display.GetWidth() - self:GetWidth()
			local max_y = Turbine.UI.Display.GetHeight() - self:GetHeight()
			if x > max_x then
				x = max_x
			end
			if y > max_y then
				y = max_y
			end


            self:SetPosition( x, y )
            
		end
	end
	
	self.topBar.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
            self.dragging = false

			LootSettings["window"]["left"],LootSettings["window"]["top"] = self:GetPosition()
				
			SaveSettings()

		end
	end
	
	self.exit_button = Turbine.UI.Lotro.Button()
    self.exit_button:SetParent(self.Logs.titelBack)
    self.exit_button:SetSize(20,20)
    self.exit_button:SetPosition(self.Logs.titelBack:GetWidth()-40,3)
    self.exit_button:SetText("X")
	self.exit_button:SetVisible(true)
	self.exit_button.Click = function(sender, args)
        self:Close()
    end

	self.resize_bottom = Turbine.UI.Control()
    self.resize_bottom:SetSize(self:GetWidth(),5)
    self.resize_bottom:SetPosition(0, self:GetHeight()-5)
	self.resize_bottom:SetParent(self)
	self.resize_bottom:SetZOrder(7)
	--Bottom
	self.resize_bottom.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.draggingSize = true	

			self.dragSizeStartX = args.X
			self.dragSizeStartY = args.Y

		end
	end

	self.resize_bottom.MouseMove = function( sender, args )
		if self.draggingSize then
			local x,y = self:GetSize()
			y = y  + ( args.Y - self.dragSizeStartY )

			self:Resize(x, y)
			
		end
	end

	self.resize_bottom.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.draggingSize = false

				LootSettings["window"]["width"] = self:GetWidth()-10
				LootSettings["window"]["height"] = self:GetHeight()

				SaveSettings()

		end
		
	end

    self.resize_right = Turbine.UI.Control()
    self.resize_right:SetSize(5,self:GetHeight())
    self.resize_right:SetPosition(self:GetWidth()-5, 0)
	self.resize_right:SetParent(self)
	self.resize_right:SetZOrder(8)
	--Right
	self.resize_right.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.draggingSize = true	

			self.dragSizeStartX = args.X
			self.dragSizeStartY = args.Y

		end
	end

	self.resize_right.MouseMove = function( sender, args )
		if self.draggingSize then
			local x,y = self:GetSize()
			x = x  + ( args.X - self.dragSizeStartX )

			self:Resize(x, y)
			
		end
	end

	self.resize_right.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.draggingSize = false

				LootSettings["window"]["width"] = self:GetWidth()-10
				LootSettings["window"]["height"] = self:GetHeight()
				
				SaveSettings()
			end

		
	end

    self.resize_corner = Turbine.UI.Control()
    self.resize_corner:SetSize(10,10)
    self.resize_corner:SetPosition(self:GetWidth()-10, self:GetHeight()-10)
	self.resize_corner:SetParent(self)
	self.resize_corner:SetZOrder(9)
	--Corner
    self.resize_corner.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
            self.draggingSize = true	

			self.dragSizeStartX = args.X
            self.dragSizeStartY = args.Y

		end
	end
	
	self.resize_corner.MouseMove = function( sender, args )
		if self.draggingSize then
			local x,y = self:GetSize()
			x = x  + ( args.X - self.dragSizeStartX )
            y = y  + ( args.Y - self.dragSizeStartY )

            self:Resize(x, y)
            
		end
	end
	
	self.resize_corner.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
            self.draggingSize = false

				LootSettings["window"]["width"] = self:GetWidth()-10
				LootSettings["window"]["height"] = self:GetHeight()

                SaveSettings()

        end
        
    end

	self.bossname_hover = Turbine.UI.Window()
	self.bossname_hover:SetSize(100,26)
	self.bossname_hover:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	self.bossname_hover:SetZOrder(100)
	self.bossname_hover:SetMouseVisible(false)
	self.bossname_label = Turbine.UI.Label()
	self.bossname_label:SetParent(self.bossname_hover)
	self.bossname_label:SetPosition(1,1)
	self.bossname_label:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.bossname_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.bossname_label:SetSize(self.bossname_hover:GetWidth()-2, self.bossname_hover:GetHeight()-2)
	self.bossname_label:SetBackColor(Turbine.UI.Color.Black)
	self.bossname_label:SetMouseVisible(false)

	self:ChangeSelection(nil, currentIndex)

	self:SetVisible(true)

end

function Window:Reset()

	self.InstanceSelect:FillControls()
	self:ChangeSelection(nil, currentIndex)

end

function Window:ShowBossName(bool, text, left, top)
	if bool then
		self.bossname_hover:SetPosition(left-50 , top-26)
		self.bossname_label:SetText(text)
	end
	self.bossname_hover:SetVisible(bool)
end



function Window:Closed()
	self.bossname_hover:Close()
	self.Logs:Close()
	self.InstanceSelect:Close()
	CloseSettings()
end

function Window:ShowAllPlayerLog()
	self.Logs:ShowAllPlayerLog(self.selected_content, self.selected_instance)
end

function Window:ShowPlayerLog()
	self.Logs:ShowPlayerLog(self.selected_content, self.selected_instance)
end

function Window:ShowContentLog()
	self.Logs:ShowContentLog(self.selected_content, self.selected_instance)
end

function Window:ShowInstanceLog()
	self.Logs:ShowInstanceLog(self.selected_content, self.selected_instance)
end

function Window:ChangeSelection(content, instance)

	self.selected_content = content
	self.selected_instance = instance

	if content == nil then -- show player

		if instance == nil then -- show all player
			self:ShowAllPlayerLog()
		else
			self:ShowPlayerLog()
		end
		
		return
	else-- show content
		
		if instance == nil then 
			self:ShowContentLog()
		else
			self:ShowInstanceLog()
		end

	end

end

function Window:LootUpdatedSettings()

	self:ChangeSelection(self.selected_content, self.selected_instance)

end

function Window:Resize(width, height)

	if width < 820 then
		width = 820
	end
	if height < 200 then
		height = 200
	end


	self:SetSize(width, height)
	self.InstanceSelect:Resize(INSTANCESELECT_WIDTH, height)
	self.Logs:Resize(width-INSTANCESELECT_WIDTH-10, height)
	self.exit_button:SetPosition(self.Logs.titelBack:GetWidth()-40,3)

	self.resize_bottom:SetPosition(0, height - 5)
	self.resize_bottom:SetSize(width - 10, 5)
	self.resize_right:SetPosition(width - 5, 0)
	self.resize_right:SetSize(5, height - 10)
	self.resize_corner:SetPosition(width - 10, height - 10)

end
---------------------------------------------------------------------
--== Logs ===--
---------------------------------------------------------------------

WindowLogs = class( Turbine.UI.Window )

function WindowLogs:Constructor(parent)
	Turbine.UI.Window.Constructor( self )

	self.parent = parent

	self.selected_instance = nil
	self.selected_content = nil

	local left = INSTANCESELECT_WIDTH + 10

	self:SetPosition(left,0)
	self:SetSize(LootSettings["window"]["width"] - left, LootSettings["window"]["height"])
	self:SetMouseVisible(false)

	self.frame = Turbine.UI.Window()
	self.frame:SetParent(self)
	self.frame:SetSize(self:GetSize())
	self.frame:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	self.frame:SetOpacity(WINDOW_OPACITY)
	self.frame:SetZOrder(1)
	self.frame:SetMouseVisible(false)

	self.background = Turbine.UI.Control()
	self.background:SetParent(self.frame)
	self.background:SetPosition(5,25)
	self.background:SetSize(self:GetWidth()-10, self:GetHeight()-30)
	self.background:SetBackColor(Turbine.UI.Color.Black)

	self.menu_bar = Turbine.UI.Window()
	self.menu_bar:SetParent(self.background)
	self.menu_bar:SetPosition(1,1)
	self.menu_bar:SetSize(self.background:GetWidth()-2, 36)
	self.menu_bar:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
	self.menu_bar:SetVisible(true)

	self.titelBack = Turbine.UI.Window()
	self.titelBack:SetParent(self)
	self.titelBack:SetZOrder(5)
	self.titelBack:SetSize(self:GetWidth()-5, 25)
	self.titelBack:SetMouseVisible(false)

	self.titel = Turbine.UI.Label()
	self.titel:SetParent(self.titelBack)
	self.titel:SetSize(self.titelBack:GetWidth(), 25)
	self.titel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.titel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
	self.titel:SetText("LootLogs")
	self.titel:SetMouseVisible(false)

	self.foreground = Turbine.UI.Window()
	self.foreground:SetParent(self)
	self.foreground:SetPosition(5,25)
	self.foreground:SetSize(self:GetWidth()-10, self:GetHeight()-30)
	self.foreground:SetZOrder(7)

	self.quickslot = Turbine.UI.Lotro.Quickslot()
	self.quickslot:SetParent(self.foreground)
	self.quickslot:SetPosition(2, 2)
	self.quickslot:SetSize(32,32)
	self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, _G.RaidLocks_Shortcut))

	self.notification_checkbox = Turbine.UI.Lotro.CheckBox()
	self.notification_checkbox:SetParent(self.foreground)
	self.notification_checkbox:SetSize(200,28)
	self.notification_checkbox:SetPosition(50,7)
	self.notification_checkbox:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.notification_checkbox:SetText(_G.ShowNotification_Text)
	self.notification_checkbox:SetChecked(LootSettings["show_notifications"])
	self.notification_checkbox.CheckedChanged = function()
		LootSettings["show_notifications"] = self.notification_checkbox:IsChecked()
	end

	self.clearButton = Turbine.UI.Lotro.Button()
	self.clearButton:SetParent(self.foreground)
	self.clearButton:SetPosition(self.foreground:GetWidth() - 82, 8)
	self.clearButton:SetWidth(80)
	self.clearButton:SetText(_G.ClearLogs_ButtonText)
	self.clearButton.Click = function()

		ClearSaveFile()
		self.parent:Reset()

	end

	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self.foreground)
	self.listbox:SetLeft(25)
	self.listbox:SetTop(50)
	self.listbox:SetSize(self.foreground:GetWidth() - 50, self.foreground:GetHeight()-50)

	self.scroll = Turbine.UI.Lotro.ScrollBar()
    self.scroll:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.scroll:SetParent(self.listbox)
    self.scroll:SetPosition(self.listbox:GetWidth()-12,0)
    self.scroll:SetWidth(12)
    self.scroll:SetHeight(self.listbox:GetHeight())
    self.scroll:SetZOrder(100)
	self.listbox:SetVerticalScrollBar(self.scroll)

	self.titelBack:SetVisible(true)
	self:SetVisible(true)
	self.foreground:SetVisible(true)
	self.frame:SetVisible(true)

end

function WindowLogs:Closed()
	self.frame:Close()
	self.titelBack:Close()
	self.foreground:Close()
end

function WindowLogs:Resize(width, height)

	self:SetSize(width, height)
	self.frame:SetSize(self:GetSize())
	self.titelBack:SetWidth(self:GetWidth()-5)
	self.titel:SetWidth(self.titelBack:GetWidth())
	self.background:SetSize(self:GetWidth()-10, self:GetHeight()-30)
	self.foreground:SetSize(self:GetWidth()-10, self:GetHeight()-30)
	self.listbox:SetSize(self.foreground:GetWidth() - 50, self.foreground:GetHeight()-50)
	self.scroll:SetPosition(self.listbox:GetWidth()-12,0)
	self.scroll:SetHeight(self.listbox:GetHeight())
	self.clearButton:SetLeft(self.foreground:GetWidth() - 82)
	self.menu_bar:SetWidth(self.foreground:GetWidth()-2)

	for i=1, self.listbox:GetItemCount(), 1 do
		self.listbox:GetItem(i):Resize(self.foreground:GetWidth() - 50)
	end

end

function WindowLogs:ShowAllPlayerLog(content, instance)
	self.selected_instance = instance
	self.selected_content = content

	self.listbox:ClearItems()

	local contentHeader = Turbine.UI.Label()
	contentHeader:SetSize(self.listbox:GetWidth(), 50)
	contentHeader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	contentHeader:SetFont(Turbine.UI.Lotro.Font.Verdana23)
	contentHeader:SetFontStyle(Turbine.UI.FontStyle.Outline)
	contentHeader:SetText(_G.Character_HeaderText)
	contentHeader:SetMouseVisible(false)
	function contentHeader:Resize(width)
		contentHeader:SetWidth(width)
	end
	self.listbox:AddItem(contentHeader)

	for key, value in ipairs(LootList) do

		self.listbox:AddItem(InstanceLog(value,self.selected_content , key, self.listbox:GetWidth(), true))

	end

end

function WindowLogs:ShowPlayerLog(content, instance)
	self.selected_instance = instance
	self.selected_content = content

	self.listbox:ClearItems()

	self.listbox:AddItem(InstanceLog(LootList[self.selected_instance],self.selected_content , key, self.listbox:GetWidth(), true))

end

function WindowLogs:ShowContentLog(content, instance)
	self.selected_instance = instance
	self.selected_content = content

	self.listbox:ClearItems()

	local contentHeader = Turbine.UI.Label()
	contentHeader:SetSize(self.listbox:GetWidth(), 50)
	contentHeader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	contentHeader:SetFont(Turbine.UI.Lotro.Font.Verdana23)
	contentHeader:SetFontStyle(Turbine.UI.FontStyle.Outline)
	contentHeader:SetText(_G.Instances[self.selected_content]["name"])
	contentHeader:SetMouseVisible(false)
	function contentHeader:Resize(width)
		contentHeader:SetWidth(width)
	end

	self.listbox:AddItem(contentHeader)

	for key, value in ipairs(_G.Instances[self.selected_content]["instances"]) do

		self.listbox:AddItem(InstanceLog(value,self.selected_content , key, self.listbox:GetWidth(), false))

	end

end

function WindowLogs:ShowInstanceLog(content, instance)
	self.selected_instance = instance
	self.selected_content = content

	self.listbox:ClearItems()

	self.listbox:AddItem(InstanceLog(_G.Instances[self.selected_content]["instances"][self.selected_instance],self.selected_content , self.selected_instance, self.listbox:GetWidth()))

end

---------------------------------------------------------------------
--== InstanceLog ===--
---------------------------------------------------------------------
--LootList[currentIndex]["loot"][contentIndex][instanceIndex][bossindex][chestIndex]
InstanceLog = class( Turbine.UI.Control )

function InstanceLog:Constructor(instance, contentIndex, instanceIndex, width, player)
	Turbine.UI.Control.Constructor( self )

	self.width = width
	self.instance = instance
	self.instanceIndex = instanceIndex
	self.contentIndex = contentIndex
	self.player = player

	self.background = Turbine.UI.Control()
	self.background:SetParent(self)

	self.background:SetMouseVisible(false)
	self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))

	self.titel = Turbine.UI.Label()
	self.titel:SetParent(self)
	self.titel:SetPosition(5,5)

	self.titel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.titel:SetFont(Turbine.UI.Lotro.Font.Verdana20)
	self.titel:SetFontStyle(Turbine.UI.FontStyle.Outline)
	if not(player) then
		self.titel:SetForeColor(Turbine.UI.Color.Orange)
	end
	self.titel:SetText(instance["name"])
	self.titel:SetMouseVisible(false)

	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self.background)
	self.listbox:SetTop(30)
	self.listbox:SetLeft(30)
	--self.listbox:SetReverseFill(true)

	self:FillListBox()

	self:Resize(width)


end

function InstanceLog:FillListBox()

	self.listbox:ClearItems()

	if self.player ~= true then

		local v = _G.Instances[self.contentIndex]["instances"][self.instanceIndex]

		--for key,value in ipairs(v) do
		for key=table.getn(v), 1, -1 do

			local value = v[key]

			self.listbox:AddItem(TierLog(value["name"],value, self.width,  self.contentIndex, self.instanceIndex, key, self.player))

		end

	else


		for cIndex, content in ipairs(_G.Instances) do

			if self.instance["loot"][cIndex] ~= nil then

				for iIndex, ini in ipairs(content["instances"]) do

					if self.instance["loot"][cIndex][iIndex] ~= nil then

						self.listbox:AddItem(TierLog(ini["name"], self.instance["loot"][cIndex][iIndex], self.width,  self.contentIndex, self.instanceIndex, ini, self.player))

					end

				end

			end

		end

	end

end

function InstanceLog:Resize(width)

	self:SetWidth(width)
	self.background:SetWidth(width)
	self.titel:SetSize(self:GetWidth(), 25)
	self.listbox:SetWidth(self:GetWidth() - 35)

	local lb_height = 0
	for i=1, self.listbox:GetItemCount(), 1 do

		lb_height = lb_height + self.listbox:GetItem(i):GetHeight()

	end

	self:SetHeight(35 + lb_height)
	self.background:SetHeight(self:GetHeight())
	self.listbox:SetHeight(lb_height)

	for i=1, self.listbox:GetItemCount(), 1 do
		self.listbox:GetItem(i):Resize(self.listbox:GetWidth())
	end

end

---------------------------------------------------------------------
--==TierLog ===--
---------------------------------------------------------------------

TierLog = class( Turbine.UI.Control )

function TierLog:Constructor(name, log, width,  contentIndex, instanceIndex, tierIndex, player)
	Turbine.UI.Control.Constructor( self )

	self.width = width
	self.name = name
	self.log = log
	self.instanceIndex = instanceIndex
	self.contentIndex = contentIndex
	self.tierIndex = tierIndex
	self.player = player

	self.background = Turbine.UI.Control()
	self.background:SetParent(self)
	self.background:SetMouseVisible(false)
	self.background:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

	self.name = Turbine.UI.Label()
	self.name:SetParent(self.background)
	self.name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.name:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.name:SetFontStyle(Turbine.UI.FontStyle.Outline)
	if player then
		self.name:SetForeColor(Turbine.UI.Color.Orange)
	end
	self.name:SetText(" "..name)
	self.name:SetLeft(5)
	self.name:SetMouseVisible(false)

	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self.background)
	self.listbox:SetTop(25)
	self.listbox:SetLeft(25)

	self:FillListBox()

	self:Resize(width)

end

function TierLog:FillListBox()

	self.listbox:ClearItems()

	--LootList[currentIndex]["loot"][contentIndex][instanceIndex][bossindex][chestIndex]

	if self.player ~= true then

		for k, player in ipairs(LootList) do

			if player["loot"][self.contentIndex] ~= nil then

				if player["loot"][self.contentIndex][self.instanceIndex] ~= nil then

					if player["loot"][self.contentIndex][self.instanceIndex][self.tierIndex] ~= nil then
						
						local id_list = {}
						local name_list = {}

						for j,value in ipairs(_G.Instances[self.contentIndex]["instances"][self.instanceIndex][self.tierIndex]) do

							if player["loot"][self.contentIndex][self.instanceIndex][self.tierIndex][j] ~= nil then

								id_list[table.getn(id_list)+1] = player["loot"][self.contentIndex][self.instanceIndex][self.tierIndex][j]
								name_list[table.getn(name_list)+1] = value["name"]

							else
								id_list[table.getn(id_list)+1] = { value = "-" , reset = 0 }
								name_list[table.getn(name_list)+1] = value["name"]
							end

						end

						self.listbox:AddItem(PlayerLog(player["name"], id_list, name_list, self.width-65))

					end
					

				end

			end

		end

	else

		for tIndex, tier in ipairs(self.tierIndex) do

			if self.log[tIndex] ~= nil then

				local id_list = {}
				local name_list = {}

				for j,value in ipairs(tier) do

					if self.log[tIndex][j] ~= nil then

						id_list[table.getn(id_list)+1] = self.log[tIndex][j]
						name_list[table.getn(name_list)+1] = value["name"]

					else
						id_list[table.getn(id_list)+1] = { value = "-" , reset = 0 }
						name_list[table.getn(name_list)+1] = value["name"]
					end

				end

				self.listbox:AddItem(PlayerLog(tier["name"], id_list, name_list, self.width-65))

			end

		end

	end

end

function TierLog:Resize(width)

	local lb_height = 0
	for i=1, self.listbox:GetItemCount(), 1 do

		lb_height = lb_height + self.listbox:GetItem(i):GetHeight()

	end

	self:SetSize( width, 30 + lb_height )
	self.name:SetSize(width, 20)
	self.background:SetSize( width, 28 + lb_height )
	self.listbox:SetSize(width-30, lb_height)

	for i=1, self.listbox:GetItemCount(), 1 do
		self.listbox:GetItem(i):Resize(self.listbox:GetWidth())
	end

end


---------------------------------------------------------------------
--== PlayerLog ===--
---------------------------------------------------------------------

PlayerLog = class( Turbine.UI.Control )

function PlayerLog:Constructor(name, log, name_list, width)
	Turbine.UI.Control.Constructor( self )

	self.name = name
	self.log = log
	self.name_list = name_list

	self.background = Turbine.UI.Control()
	self.background:SetParent(self)
	self.background:SetMouseVisible(false)
	self.background:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))

	self.name = Turbine.UI.Label()
	self.name:SetParent(self.background)
	self.name:SetPosition(5,0)
	self.name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.name:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.name:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.name:SetText(name)
	self.name:SetMouseVisible(false)

	local smali = 50000000000

	for k,v in ipairs(self.log) do

		if v["reset"] ~= 0 and v["reset"] < smali then

			smali = v["reset"]

		end

	end

	self.reset = Turbine.UI.Label()
	self.reset:SetParent(self.background)
	self.reset:SetPosition(5,0)
	self.reset:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
	self.reset:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.reset:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.reset:SetText( ResetToString(smali))
	self.reset:SetMouseVisible(false)

	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self.background)
	self.listbox:SetMaxItemsPerLine(1)
	self.listbox:SetLeft(100)

	self:FillListBox()

	self:Resize(width)

end

function PlayerLog:FillListBox()

	local bool = false

	for k,v in ipairs(self.log) do

		local item = Turbine.UI.Label()
		item:SetParent(self.background)
		item:SetSize(50,20)
		item:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
		item:SetFont(Turbine.UI.Lotro.Font.Verdana14)
		item:SetFontStyle(Turbine.UI.FontStyle.Outline)
		item:SetText(v["value"])
		item.MouseEnter = function()
			ShowBossName(true, self.name_list[k], item:PointToScreen(2,0))
		end
		item.MouseLeave = function()
			ShowBossName(false)
		end

		self.listbox:AddItem(item)

			if tonumber(v["value"]) == nil or tonumber(v["value"]) > 0 then
				bool = true
			end


	end

	if bool then
		self.background:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
	else
		self.background:SetBackColor(Turbine.UI.Color(0.4,0,0))
	end

end

function PlayerLog:Resize(width)

	self:SetSize( width, 22 )
	self.background:SetSize( width , 20 )
	self.listbox:SetSize(self.background:GetWidth()-50,20)
	self.name:SetSize(self.background:GetSize())
	self.reset:SetSize(self.background:GetWidth()-10, self.background:GetHeight())

end

---------------------------------------------------------------------
--== ListBox ===--
---------------------------------------------------------------------

WindowInstanceSelect = class( Turbine.UI.Window )

function WindowInstanceSelect:Constructor(parent)
	Turbine.UI.Window.Constructor( self )

	self.parent = parent
	self.controls = {}
	self.searchText = nil

	self:SetSize(INSTANCESELECT_WIDTH, LootSettings["window"]["height"])
	self:SetMouseVisible(false)

	self.frame = Turbine.UI.Window()
	self.frame:SetParent(self)
	self.frame:SetSize(self:GetSize())
	self.frame:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	self.frame:SetOpacity(WINDOW_OPACITY)
	self.frame:SetZOrder(1)
	self.frame:SetMouseVisible(false)

	self.background = Turbine.UI.Control()
	self.background:SetParent(self.frame)
	self.background:SetPosition(5,50)
	self.background:SetSize(self:GetWidth()-10, self:GetHeight()-55)
	self.background:SetBackColor(Turbine.UI.Color.Black)


	self.titelBack = Turbine.UI.Window()
	self.titelBack:SetParent(self)
	self.titelBack:SetZOrder(5)
	self.titelBack:SetSize(self:GetWidth(), 25)
	self.titelBack:SetMouseVisible(false)

	self.titel = Turbine.UI.Label()
	self.titel:SetParent(self.titelBack)
	self.titel:SetSize(self:GetWidth(), 25)
	self.titel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.titel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
	self.titel:SetText(_G.Instances_HeaderText )
	self.titel:SetMouseVisible(false)

	self.foreground = Turbine.UI.Window()
	self.foreground:SetParent(self)
	self.foreground:SetPosition(5,25)
	self.foreground:SetSize(self:GetWidth()-10, self:GetHeight()-30)
	self.foreground:SetZOrder(7)

	self.search = Turbine.UI.Lotro.TextBox()
	self.search:SetSize(self.foreground:GetWidth(), 25)
	self.search:SetParent(self.foreground)
	self.search:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.search:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    self.search:SetFontStyle(Turbine.UI.FontStyle.None)
    self.search:SetText("Search ...")
    self.search.FocusGained = function(sender, args)
		if self.searchText == nil then
			self.search:SetText("")
		end		
	end
	self.search.FocusLost = function(sender, args)
		if self.searchText == nil then
			self.search:SetText("Search ...")
		end
	end
	self.search.TextChanged = function(sender, args)
		if self.search:GetText() == "" then
			self.searchText = nil
		else
			self.searchText = string.lower(self.search:GetText())
		end
		self:FillListBox()
	end

	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self.foreground)
	self.listbox:SetTop(27)
	self.listbox:SetSize(self.foreground:GetWidth(), self.foreground:GetHeight()-27)

	self.scroll = Turbine.UI.Lotro.ScrollBar()
    self.scroll:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.scroll:SetParent(self.listbox)
    self.scroll:SetPosition(self.listbox:GetWidth()-12,0)
    self.scroll:SetWidth(12)
    self.scroll:SetHeight(self.listbox:GetHeight())
    self.scroll:SetZOrder(100)
	self.listbox:SetVerticalScrollBar(self.scroll)
	
	

	self:FillControls()

	self.foreground:SetVisible(true)
	self.titelBack:SetVisible(true)
	self:SetVisible(true)
	self.frame:SetVisible(true)



end

function WindowInstanceSelect:Closed()
	self.frame:Close()
	self.titelBack:Close()
	self.foreground:Close()
end

function WindowInstanceSelect:Resize(width, height)

	self:SetHeight(height)
	self.frame:SetHeight(height)
	self.background:SetHeight(height-55)
	self.foreground:SetHeight(height-30)
	self.listbox:SetHeight(self.foreground:GetHeight()-27)
	self.scroll:SetHeight(self.listbox:GetHeight())

end

function WindowInstanceSelect:FillListBox()

	self.listbox:ClearItems()

	for i=1, table.getn(self.controls), 1 do

		if self.controls[i]:CheckAdd(self.searchText) then
			self.listbox:AddItem(self.controls[i])
		end
		
	end

end

function WindowInstanceSelect:FillControls()

	self.controls = {}
	local controlIndex = 1

	local contentCount = table.getn(_G.Instances)

	for i=contentCount, 1, -1 do

		self.controls[controlIndex] = ContentItem(controlIndex, i, self)
		controlIndex = controlIndex+1

	end

	self.controls[controlIndex] = ContentItem(controlIndex, nil, self)

	self:FillListBox()

end

function WindowInstanceSelect:Select(control_index)

	self.selected = control_index

	for i, control in ipairs(self.controls) do
		if control.control_index ~= control_index then
			control:Reset()
		end
	end

end

function WindowInstanceSelect:ChangeSelection(content, instance)
	self.parent:ChangeSelection(content, instance)
end

---------------------------------------------------------------------
--== ContentItem ===--
---------------------------------------------------------------------

ContentItem = class( Turbine.UI.Control )

function ContentItem:Constructor(control_index, index, parent)
	Turbine.UI.Control.Constructor( self )

	self.parent = parent
	self.control_index = control_index
	self.index = index
	self.searchText = nil
	self.selected = false

	self.selection = nil

	self.controls = {}

	self:SetWidth(INSTANCESELECT_WIDTH-10)

	self.background = Turbine.UI.Control()
	self.background:SetParent(self)
	self.background:SetWidth(self:GetWidth())
	self.background:SetMouseVisible(false)
	self.background:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))

	self.text = Turbine.UI.Label()
	self.text:SetParent(self.background)
	self.text:SetPosition(5,5)
	self.text:SetSize(self.background:GetWidth() - 10, 20)
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
	self.text:SetFont(Turbine.UI.Lotro.Font.Verdana18)	
	self.text:SetFontStyle(Turbine.UI.FontStyle.Outline)
	if index ~= nil then
		self.text:SetText(_G.Instances[index]["name"])
	else
		self.text:SetText(_G.Character_HeaderText)
	end
	self.text:SetMouseVisible(false)

	self.listbox = Turbine.UI.ListBox()
	self.listbox:SetParent(self)
	self.listbox:SetWidth(self:GetWidth() - 10)
	self.listbox:SetPosition(10, 24)
	self.listbox:SetMouseVisible(false)

	self:FillControls()
	self:ResetHeight()

end

function ContentItem:MouseEnter()
	if self.selected == false then
		self.background:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2))
	end
end

function ContentItem:MouseLeave()
	if self.selected == false then
		self.background:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
	end
end

function ContentItem:MouseClick()
	for i, control in ipairs(self.controls) do
		control:Reset()
	end

	self.selected = true 
	self.parent:Select(self.control_index)
	self.background:SetBackColor(Turbine.UI.Color(0.4,0.4,0.4))

	self.parent:ChangeSelection(self.index, nil)
end

function ContentItem:FillListBox()

	self.listbox:ClearItems()

	for i=1, table.getn(self.controls), 1 do

		if self.controls[i]:CheckAdd(self.searchText) then
			self.listbox:AddItem(self.controls[i])
		end
		
	end

	self:ResetHeight()
	if self.listbox:GetItemCount() > 0 then
		return true
	end

	return false

end

function ContentItem:FillControls()

	self.controls = {}

	if self.index ~= nil then

		for i=1, table.getn(_G.Instances[self.index]["instances"]), 1 do

			self.controls[i] = InstanceItem(_G.Instances[self.index]["instances"][i]["name"],self.index, i, self)

		end

	else 

		for pIndex, player in ipairs(LootList) do

			self.controls[pIndex] = InstanceItem(player["name"],self.index, pIndex, self)

		end

	end

	self:FillListBox()

end

function ContentItem:ResetHeight()

	local lb_height = (self.listbox:GetItemCount() * 27)
	local height = 31 + lb_height

	self:SetHeight(height)
	self.background:SetHeight(self:GetHeight()-2)
	self.listbox:SetHeight(lb_height)

end

function ContentItem:CheckAdd(searchText)

	if searchText == nil then
		self.searchText = nil
		self:FillListBox()
		return true
	end

	if self.index ~= nil then
		if string.find(string.lower(_G.Instances[self.index]["name"]), searchText) then
			
			self.searchText = nil
			self:FillListBox()

			return true
		end
	else
		if string.find("chararcter", searchText) then
			
			self.searchText = nil
			self:FillListBox()

			return true
		end
	end

	self.searchText = searchText

	return self:FillListBox()

end

function ContentItem:Reset()
	self.selected = false
	self.background:SetBackColor()

	for i, control in ipairs(self.controls) do
		control:Reset()
	end
end

function ContentItem:Select(control_index)
	self.selection = control_index

	for i, control in ipairs(self.controls) do
		if control.index ~= control_index then
			control:Reset()
		end
	end

	self.parent:ChangeSelection(self.index, control_index)

	self.selected = true 
	self.parent:Select(self.control_index)
	self.background:SetBackColor(Turbine.UI.Color(0.4,0.4,0.4))
end

---------------------------------------------------------------------
--== InstanceItem ===--
---------------------------------------------------------------------

InstanceItem = class( Turbine.UI.Control )

function InstanceItem:Constructor(txt, contentIndex, index, parent)
	Turbine.UI.Control.Constructor( self )

	self.parent = parent
	self.contentIndex = contentIndex
	self.index = index
	self.txt = txt
	self.selected = false

	self:SetSize(INSTANCESELECT_WIDTH-10, 27)

	self.background = Turbine.UI.Control()
	self.background:SetParent(self)
	self.background:SetTop(2)
	self.background:SetSize(self:GetWidth(), self:GetHeight()-2)
	self.background:SetMouseVisible(false)
	self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))


	self.text = Turbine.UI.Label()
	self.text:SetParent(self.background)
	self.text:SetLeft(5)
	self.text:SetSize(self.background:GetWidth() - 5, self.background:GetHeight())
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.text:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.text:SetForeColor(Turbine.UI.Color.Orange)	
	self.text:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.text:SetText(self.txt)
	self.text:SetMouseVisible(false)

end

function InstanceItem:MouseEnter()
	if self.selected == false then
		self.background:SetBackColor(Turbine.UI.Color(0.4,0.4,0.4))
	end
end

function InstanceItem:MouseLeave()
	if self.selected == false then
		self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	end
end

function InstanceItem:MouseClick()
	self.selected = true 
	self.parent:Select(self.index)
	self.background:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
end

function InstanceItem:CheckAdd(searchText)

	if searchText == nil then

		return true
	end

	if string.find(string.lower(self.txt), searchText) then

		return true
	end

	return false

end

function InstanceItem:Reset()
	self.background:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3))
	self.selected = false
end